include \masm32\include\masm32rt.inc

; CONSOLE assemble and link

opsize MACRO arg
ifndef OpSizeDD
	.data?
	OpSizeDD	dd ?
	.code
	echo dd defined
endif
ifb <arg>
	echo IsBlank
	call @F
@@:	pop OpSizeDD   ; contains EIP of pop instruction
else
	echo IsNotBlank <arg>
	call @F
@@:	push eax
	mov eax, [esp+4]
	sub eax, 11
	sub OpSizeDD, eax   ; contains EIP of pop instruction
	neg OpSizeDD
	pop eax
	add esp, 4
	pushad
	print chr$(13, 10, <arg>, 9)
	print str$(OpSizeDD)
	print chr$(" bytes")
	; invoke MessageBox, 0, str$(OpSizeDD), chr$(<arg>), MB_OK
	popad
endif
ENDM

.code
AppName	db "Get the size of a piece of code:", 0
start:

print offset AppName, 13, 10

opsize
	push eax
opsize "push eax"

opsize
	pop eax
opsize "pop eax  "

opsize
	pushad
	popad
opsize "pushad & popad (/2)"

opsize
	inc eax
opsize "inc eax    "

opsize
	add eax, 1
opsize "add eax, 1"

opsize
	mov eax, -1
opsize "mov eax, -1"

opsize
	or eax, -1
opsize "or eax, -1"

opsize
	mov eax, 0
opsize "mov eax, 0"

opsize
	and eax, 0
opsize "and eax, 0"

opsize
	mov edx, offset AppName
opsize "mov edx, offset AppName"

opsize
	lea edx, AppName
opsize "lea edx, AppName"

opsize
	lea edx, [AppName+4*eax]
opsize "lea edx, [AppName+4*eax]"

opsize
	lea edx, [AppName+4*eax+8]
opsize "lea edx, [AppName+4*eax+8]"

opsize
	jmp @F
@@:
opsize "jmp @F  "

opsize
	mov ecx, 99
@@:	dec ecx
	jne @B
opsize "simple loop, version A"

opsize
	m2m ecx, 99
@@:	dec ecx
	jne @B
opsize "simple loop, version B"

opsize
	m2m ecx, 99
	.While ecx
		dec ecx
	.Endw
opsize ".While/.Endw"

opsize
	m2m ecx, 99
	.While !SIGN?
		dec ecx
	.Endw
opsize ".While not sign"

opsize
	m2m ecx, 99
	.While !ZERO?
		dec ecx
	.Endw
opsize ".While not zero (fails miserably!)"

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until Zero?
opsize ".Repeat/.Until zero?"

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until ecx==0
opsize ".Repeat/.Until ecx==0"

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until SIGN?
opsize ".Repeat/.Until sign"

print chr$(13, 10,10)
inkey "Hit any key to get outta here"
exit

end start
OPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_Tmp2Asm	1
OPT_SUSY	CONSOLE
